﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Files
{
    public partial class Form1 : Form
    {
        const int MaxPoint = 100;

        Point[] A = new Point[MaxPoint]; // Коллекция точек
        int N = 0;                       // Текущее число точек 
        int R = 4;

        public Form1()
        {
            InitializeComponent();
        }

        protected override void OnClosing(CancelEventArgs e)
        {
            e.Cancel = (MessageBox.Show("Do You wish to exit?",
                "File not saved",
                MessageBoxButtons.YesNo,
                MessageBoxIcon.Question) == DialogResult.No);
            base.OnClosing(e);
        }

        private void exitToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void Form1_MouseClick(object sender, MouseEventArgs e)
        {
            if (N < MaxPoint)
            {
                A[N].X = e.X; A[N].Y = e.Y;
                N++;
                Invalidate();
            }
            else MessageBox.Show("Maximum exceeded!");
        }

        private void Form1_Paint(object sender, PaintEventArgs e)
        {
            for (int i = 0; i < N; i++)
                e.Graphics.DrawEllipse(Pens.Black, 
                    A[i].X - R, A[i].Y - R, 2 * R, 2 * R);
        }

        private void saveToolStripMenuItem_Click(object sender, EventArgs e)
        {
            SaveFileDialog Dialog = new SaveFileDialog();
            Dialog.InitialDirectory = ".";
            Dialog.Filter="Points|*.ptr|All Files|*.*";
            Dialog.FilterIndex = 1;
            Dialog.FileName = "mypoint";
            if (Dialog.ShowDialog() == DialogResult.OK)
            {
                StreamWriter s = new StreamWriter(Dialog.FileName);
                for (int i = 0; i < N; i++)
                {
                    s.WriteLine("{0} {1}", A[i].X, A[i].Y);
                }
                s.Close();
            }
        }

        private void openToolStripMenuItem_Click(object sender, EventArgs e)
        {
            OpenFileDialog Dialog = new OpenFileDialog();
            Dialog.InitialDirectory = ".";
            Dialog.Filter = "Points (*.ptr)|*.ptr|All Files (*.*)|*.*";
            Dialog.FilterIndex = 1;
            Dialog.CheckFileExists = true;
            if (Dialog.ShowDialog() == DialogResult.OK)
            {
                try
                {
                    StreamReader s = new StreamReader(Dialog.FileName);
                    N = 0;
                    while (!s.EndOfStream)
                    {
                        string t = s.ReadLine();
                        string[] p = t.Split(' ');
                        A[N].X = int.Parse(p[0]);
                        A[N].Y = int.Parse(p[1]);
                        N++;
                        if (N == MaxPoint) break;
                    }
                    s.Close();
                    Invalidate();
                }
                catch (Exception ex)
                {
                    MessageBox.Show(ex.Message, "Error reading file",
                        MessageBoxButtons.OK,  MessageBoxIcon.Error);
                }
            }
        }
    }
}
